import Polyglot from 'node-polyglot';
import { SupportedLocales, IPhrases } from '@cloudflare/intl-types';
interface ITranslatorOptions extends Polyglot.PolyglotOptions {
    pseudoLoc?: boolean;
}
declare class Translator {
    map: {
        [key: string]: Polyglot;
    };
    currentLocale: SupportedLocales;
    options: ITranslatorOptions;
    constructor(options?: ITranslatorOptions);
    private createInstance;
    psudoLocalizePhrases: (phrases: IPhrases) => {};
    getInstance: (locale?: SupportedLocales) => Polyglot;
    getInstanceMatchingPhrase: (phrase: string) => Polyglot;
    extend: (phrases: IPhrases, locale?: SupportedLocales) => void;
    t: (phrase: string, arg?: number | Polyglot.InterpolationOptions) => string;
    tm: (phrase: string, arg?: number | Polyglot.InterpolationOptions) => any;
    clear: () => void;
    replace: (phrases: IPhrases) => void;
    locale: (locale?: SupportedLocales) => SupportedLocales;
    has: (phrase: string) => boolean;
    translateSeconds: (seconds: number) => string;
    translateObject: (phrases: IPhrases) => import("lodash").Dictionary<boolean>;
}
export default Translator;
