function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? Object(arguments[i]) : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys.push.apply(ownKeys, Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return typeof key === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (typeof input !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (typeof res !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _readOnlyError(name) { throw new TypeError("\"" + name + "\" is read-only"); }
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }
function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }
import { SupportedLocales } from './index';
var loadLocale = /*#__PURE__*/function () {
  var _ref = _asyncToGenerator(function* (locales, locale) {
    var module = yield locales[locale]();
    if (module.translations) {
      return module.translations;
    }

    // with weback 4.0 the module is loaded into the default attr
    // in older versions it is not
    return module.default ? module.default : module;
  });
  return function loadLocale(_x, _x2) {
    return _ref.apply(this, arguments);
  };
}();

//returns a function which returns a Promise resolving in phrases for a particular locale.
//loads english catalog by default and overwrites it with catalog in target language.
//so that for any phrases for which target language catalog is missing a value, the english one is used.
var makeLoadPhrases = function loadPhrases(locales) {
  var loadPhrases = /*#__PURE__*/function () {
    var _ref2 = _asyncToGenerator(function* (locale) {
      if (locale === SupportedLocales.en_US) {
        return loadLocale(locales, locale);
      }
      var [enPhrases, otherPhrases] = yield Promise.all([loadLocale(locales, SupportedLocales.en_US), loadLocale(locales, locale)]);

      // enPhrases are the English phrases and otherPhrases should be the target locale's phrases
      // otherPhrases clobbers the English phrase key if it exists
      return _objectSpread({}, enPhrases, otherPhrases);
    });
    return function loadPhrases(_x3) {
      return _ref2.apply(this, arguments);
    };
  }();
  return loadPhrases;
};
export default makeLoadPhrases;