"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _nodePolyglot = _interopRequireDefault(require("node-polyglot"));
var _intlTypes = require("@cloudflare/intl-types");
var _utilMarkdown = _interopRequireDefault(require("@cloudflare/util-markdown"));
var _mapValues = _interopRequireDefault(require("lodash/mapValues"));
var _pseudoloc = _interopRequireDefault(require("./pseudoloc"));
var _errors = require("./errors");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
_pseudoloc.default.option.delimiter = '%';
_pseudoloc.default.option.startDelimiter = '{';
_pseudoloc.default.option.endDelimiter = '}';
var Translator = /*#__PURE__*/function () {
  function Translator(options) {
    var _this = this;
    _classCallCheck(this, Translator);
    _defineProperty(this, "map", void 0);
    _defineProperty(this, "currentLocale", _intlTypes.SupportedLocales.en_US);
    _defineProperty(this, "options", void 0);
    _defineProperty(this, "psudoLocalizePhrases", function (phrases) {
      return Object.entries(phrases).reduce(function (acc, _ref) {
        var _ref2 = _slicedToArray(_ref, 2),
          key = _ref2[0],
          value = _ref2[1];
        return Object.assign(acc, _defineProperty({}, key, _pseudoloc.default.str(value)));
      }, {});
    });
    _defineProperty(this, "getInstance", function (locale) {
      if (locale) {
        return _this.map[locale];
      } else {
        return _this.map[_this.currentLocale];
      }
    });
    _defineProperty(this, "getInstanceMatchingPhrase", function (phrase) {
      var p = _this.getInstance();
      if (p.has(phrase)) {
        return p;
      } else {
        return _this.getInstance(_intlTypes.SupportedLocales.en_US);
      }
    });
    _defineProperty(this, "extend", function (phrases, locale) {
      var p = _this.getInstance(locale);
      if (_this.options.pseudoLoc) {
        phrases = _this.psudoLocalizePhrases(phrases);
      }
      p.extend(phrases);
    });
    _defineProperty(this, "t", function (phrase, arg) {
      var p = _this.getInstanceMatchingPhrase(phrase);
      if (arg) {
        if (typeof arg === 'number') {
          return p.t(phrase, arg);
        } else {
          return p.t(phrase, arg);
        }
      }
      return p.t(phrase);
    });
    _defineProperty(this, "tm", function (phrase, arg) {
      return (0, _utilMarkdown.default)(_this.t(phrase, arg));
    });
    _defineProperty(this, "clear", function () {
      _this.getInstance().clear();
    });
    _defineProperty(this, "replace", function (phrases) {
      if (_this.options.pseudoLoc) {
        phrases = _this.psudoLocalizePhrases(phrases);
      }
      _this.getInstance().replace(phrases);
    });
    _defineProperty(this, "locale", function (locale) {
      if (locale) {
        _this.currentLocale = locale;
        if (!_this.map[locale]) {
          _this.createInstance(locale);
        }
      }
      return _this.currentLocale;
    });
    _defineProperty(this, "has", function (phrase) {
      return _this.getInstanceMatchingPhrase(phrase).has(phrase);
    });
    _defineProperty(this, "translateSeconds", function (seconds) {
      // Prevent 0 seconds returning "0 days"
      if (Number(seconds) !== 0) {
        if (seconds % 86400 === 0) {
          return _this.t('time.num_days', {
            smart_count: seconds / 86400
          });
        }
        if (seconds % 3600 === 0) {
          return _this.t('time.num_hours', {
            smart_count: seconds / 3600
          });
        }
        if (seconds % 60 === 0) {
          return _this.t('time.num_minutes', {
            smart_count: seconds / 60
          });
        }
      }
      return _this.t('time.num_seconds', {
        smart_count: seconds
      });
    });
    _defineProperty(this, "translateObject", function (phrases) {
      return (0, _mapValues.default)(phrases, _this.t);
    });
    this.map = {};
    this.options = options || {};
    this.options.allowMissing = true;
    this.options.onMissingKey = function (key, options, locale) {
      if (process.env.NODE_ENV === 'staging' || process.env.NODE_ENV === 'production') {
        console.error(new _errors.TranslatorKeyNotFoundError(key));

        // If a fallback is present, display that
        if (options._) return options._;

        // Otherwise display the raw key
        return key;
      }
      if (process.env.NODE_ENV === 'test') {
        return key;
      }
      throw new Error("Translation error. The translate function was called on a key that does not exist or is in a catalog that has not yet been loaded. Key: ".concat(key, ". Locale: ").concat(locale, ". There are several reasons this might be happening, check the i18n FAQ for more information: https://guide.cloudflare-ui.com/docs/i18n#i18n-faq"));
    };
    this.locale(options && options.locale || _intlTypes.SupportedLocales.en_US);

    //clear locale and phrases since future instances of Polyglot
    //created should be based on params passed in to functions and not
    //initial options
    if (options && options.phrases) {
      options.phrases = undefined;
    }
    if (options && options.locale) {
      options.locale = undefined;
    }
  }
  _createClass(Translator, [{
    key: "createInstance",
    value: function createInstance(locale) {
      if (this.options.pseudoLoc && this.options.phrases) {
        this.options.phrases = this.psudoLocalizePhrases(this.options.phrases);
      }
      this.map[locale] = new _nodePolyglot.default(Object.assign(this.options, {
        locale: locale
      }));
    }
  }]);
  return Translator;
}();
var _default = Translator;
exports.default = _default;